#lang scheme

(define (rx pats)
  (if (null? pats)
      (lambda (in pos)
        (and (= pos (string-length in))
             pos))
      (let ([pat (car pats)])
        (cond
          [(string? pat)
           (let ([len (string-length pat)]
                 [rest (rx (cdr pats))])
             (lambda (in pos)
               (and (>= (string-length in) (+ pos len))
                    (substring=? pat in pos (+ pos len))
                    (rest in (+ pos len)))))]
          [else
           (case (car pat)
             [(or)
              (let ([a (rx (cons (cadr pat) (cdr pats)))]
                    [b (rx (cons (caddr pat) (cdr pats)))])
                (lambda (in pos)
                  (or (a in pos)
                      (b in pos))))]
             [(*)
              (let ([a (rx (cons (cadr pat) pats))] ; oops! loops forever
                    [b (rx (cdr pats))])
                (lambda (in pos)
                  (or (a in pos)
                      (b in pos))))]
             [(+)
              (rx (cons (cadr pat)
                        (cons (list '* (cadr pat))
                              (cdr pats))))]
             [(?)
              (rx (cons (list 'or (cadr pat) "")
                        (cdr pats)))]
             [else
              (error "bad pattern")])]))))

(define (substring=? pat in start end)
  (for/and ([i (in-range start end)]
            [j (in-naturals)])
    (char=? (string-ref pat j) (string-ref in i))))

; ((rx '("a" (* "b") (or (? "c") (+ "d")))) "abbc" 0)
